﻿ Liquid_Wealth.AuctioneerAddons = {
    ["auc-advanced"] = {name="Auc-Advanced", func="GetAucAdv", check="Auc-Advanced"},
	["auctioneer"] = {name="Auctioneer", func="GetAuc4", check="Auctioneer"},
	["auctionator"] = {name="Auctionator", func="GetAuctionator", check="Auctionator"},
	["auctionlite"] = {name="AuctionLite", func="GetAuctionLite", check="AuctionLite"},
	["auctionmaster"] = {name="AuctionMaster", func="GetAuctionMaster", check="AuctionMaster"},
};

--Auctionator
function Liquid_Wealth:GetAuctionator(itemLink)
	return Atr_GetAuctionBuyout(itemLink);
end

-- Auc Advanced
function Liquid_Wealth:GetAucAdv(itemLink)
    sellPrice, _ = AucAdvanced.API.GetMarketValue(itemLink, AucAdvanced.GetFaction());
	return sellPrice;
end

-- Auctioneer 4.0
function Liquid_Wealth:GetAuc4(itemLink)
	local _, _, buyMedian = Auctioneer.Statistic.GetSuggestedResale(Auctioneer.ItemDB.CreateItemKeyFromLink(itemLink), nil, 1);
	return buyMedian;
end

-- AuctionLite
function Liquid_Wealth:GetAuctionLite(itemLink)
	return AuctionLite:GetAuctionValue(itemLink)
end

-- AuctionLite
function Liquid_Wealth:GetAuctionMaster(itemLink)
		local avgBid, avgBuy, numBid, numBuy = AucMasGetAuctionInfo(itemLink, false)
		return avgBuy or 0, numBuy or 0
end


function Liquid_Wealth:AucDeposit(itemLink)
	-- local tempTotal=0;
	-- local itemsPrice=0;
	-- if IsAddOnLoaded(Liquid_Wealth.db.profile.selectedVendorAddon) then --Check To See If Addon InList Is Enabled
		-- itemsPrice = self[self.vendoraddons[string.lower(self.db.profile.selectedVendorAddon)].func](self,itemLink); --Runs The Function In The List
		-- if (Liquid_Wealth.db.profile.selectedAhFaction=="factioned") then
			-- if(Liquid_Wealth.db.profile.selectedAhTime==12) then
				-- tempTotal=0.15*itemsPrice
			-- elseif(Liquid_Wealth.db.profile.selectedAhTime==24) then
				-- tempTotal=2*(0.15*itemsPrice)
			-- elseif(Liquid_Wealth.db.profile.selectedAhTime==48) then
				-- tempTotal=2*(0.15*itemsPrice)
			-- end
		-- elseif(Liquid_Wealth.db.profile.selectedAhFaction=="neutral") then 
			-- if(Liquid_Wealth.db.profile.selectedAhTime==12) then
				-- tempTotal=0.75*itemsPrice
			-- elseif(Liquid_Wealth.db.profile.selectedAhTime==24) then
				-- tempTotal=2*(0.75*itemsPrice)
			-- elseif(Liquid_Wealth.db.profile.selectedAhTime==48) then
				-- tempTotal=2*(0.75*itemsPrice)
			-- end
		-- end
	-- end
	-- return tempTotal;
end

function Liquid_Wealth:GetBagValueAuction(bagId)
	local bagTotal = 0; -- Using Auctioneer buyout median price
	if IsAddOnLoaded(Liquid_Wealth.db.profile.selectedAuctionAddon) then
		local bagSlots = GetContainerNumSlots(bagId);
		if (bagSlots > 0) then
			local bagName = GetBagName(bagId);
			-- Need To Check For Item SoulBound & QuestItems BC They Might Not Be Vendered Or AH'ed
			for slot = 1, bagSlots do
				local PriceTotal=0;
				local itemsPrice=0;
				local itemsDeositCost=0;
				local itemLink = GetContainerItemLink(bagId, slot);
				if (itemLink) then
					local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bagId, slot); -- Needed for itemCount
					if Liquid_Wealth:IsItemSoulbound(bagId, slot) then
						--The Item is soulbound so we have to call a new method to allow to add that to the vender.
					else
						itemsPrice = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self,itemLink); --Runs The Function In The List
					end
					if (itemsPrice) then
						PriceTotal=itemCount*itemsPrice;
						bagTotal = bagTotal + floor(PriceTotal);
						--if (Liquid_Wealth.db.profile.AucDeposit) then
						--itemsDeositCost=itemsDeositCost+(itemCount*floor(Liquid_Wealth:AucDeposit(itemLink)))
						--end
					end
				end
			end
		end
	end
	return bagTotal;
end

function Liquid_Wealth:GetItemValueAuction(itemLink)
	local itemsPrice=0;
	if (itemLink) then
		if IsAddOnLoaded(Liquid_Wealth.db.profile.selectedAuctionAddon) then --Check To See If Addon InList Is Enabled
			itemsPrice = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self,itemLink); --Runs The Function In The List
		end
	end
	return itemsPrice or 0;
end
