﻿function Liquid_Wealth:CheckMasterDatabase()
	if not Liquid_Wealth.db.realm.guild then --Check To See If Guilds Master Index Is Present
		Liquid_Wealth.db.realm.guild = {};
	end
	if not Liquid_Wealth.db.realm.toon then --Check To See If Toons Master Index Is Present
		Liquid_Wealth.db.realm.toon = {};
	end
	if (not Liquid_Wealth.db.profile.selectedAuctionAddon) or (Liquid_Wealth.db.profile.selectedAuctionAddon=="") then --Checks To See If Selected Auction Addon Is Listed
		Liquid_Wealth:SetDefaultAuctionAPI();
	end
	if not Liquid_Wealth.db.profile.scanGuildBank then --Boolen to check if users wants to scan GuildBank
		Liquid_Wealth.db.profile.scanGuildBank=true;
	end
	if not Liquid_Wealth.db.profile.displayMode then --Boolen to check if users wants to scan GuildBank
		Liquid_Wealth.db.profile.displayMode="";
		Liquid_Wealth.db.profile.gdisplayMode="";
	end
end

function Liquid_Wealth:SetDefaultAuctionAPI() --This is part of the 1st run code, it will use the 1st addon that supports aunction scaning
	for index,value in pairs(Liquid_Wealth.AuctioneerAddons) do
		if IsAddOnLoaded(value.name) then
			Liquid_Wealth.db.profile.selectedAuctionAddon = value.name
			break
		end
	end
	if(not Liquid_Wealth.db.profile.selectedAuctionAddon) or (Liquid_Wealth.db.profile.selectedAuctionAddon=="") then Liquid_Wealth.db.profile.selectedAuctionAddon=""; end --This will fix the Acution scaning code from erroring if it dont find anddon when on 1st run
end

function Liquid_Wealth:CheckGuildBank(GuildName)
	if Liquid_Wealth.db.realm.guild[GuildName] then
		return true
	end
end


function Liquid_Wealth:CovGuildBankRankToDB(tblRankList)
	local strRankList=""
	for index,value in pairs(tblRankList) do 
		strRankList = strRankList..tostring(value)..":"
	end
	return strRankList
end

function Liquid_Wealth:CovGuildBankItemDataToDB(Name,Texture,isViewable,VenderTotal,AuctionTotal) --Convert GuildTabData to my format (Name:Texture:isViewable:GuildRankLevel:VENDERTOTAL:ACUTIONTOTAL)
	return Name..":"..Texture..":"..isViewable..":"..VenderTotal..":"..AuctionTotal
end

function Liquid_Wealth:CovGuildBankItemDataFromDB(GuildName,banktab)
	if Liquid_Wealth.db.realm.guild[GuildName][banktab] == "" or Liquid_Wealth.db.realm.guild[GuildName][banktab] == nil then
		return nil
	else
		rawString = Liquid_Wealth.db.realm.guild[GuildName][banktab]
		local Name,Texture,isViewable,VenderTotal,AuctionTotal = strsplit(":",rawString);
		return Name,Texture,isViewable,VenderTotal,AuctionTotal
	end
	
end

function Liquid_Wealth:CheckGuildInfo() 
	local vguildName, vguildRankName, vguildRankIndex = GetGuildInfo("Player");
	if Liquid_Wealth.db.realm.toon[varCurrentPlayer].guildInfo == nil or Liquid_Wealth.db.realm.toon[varCurrentPlayer].guildInfo == "" then
		self:Print("Updating Guild Info")
		Liquid_Wealth:UpdateCurrentToonGuildInfo(UnitName("player"),vguildName,vguildRankIndex,vguildRankName)
	else
		if ((not vguildName == Liquid_Wealth.db.realm.toon[varCurrentPlayer].guildInfo.guildName) or (not vguildRankName == Liquid_Wealth.db.realm.toon[varCurrentPlayer].guildInfo.guildRankIndex ) or (not vguildRankIndex == Liquid_Wealth.db.realm.toon[varCurrentPlayer].guildInfo.guildRankName)) then
			self:Print("Updating Guild Info")
			Liquid_Wealth:UpdateCurrentToonGuildInfo(UnitName("player"),vguildName,vguildRankIndex,vguildRankName)
		end
	end

end

function Liquid_Wealth:UpdateCurrentToonGuildInfo(varPlayer,varGuild,varRankIndex,varRankName)
	Liquid_Wealth.db.realm.toon[varPlayer].guildInfo =
		{
			guildName=varGuild,
			guildRankIndex=varRankIndex,
			guildRankName=varRankName,
		}
end 

function Liquid_Wealth:NewToonEntery(varPlayer,varAccountType,varPSK,varSex,varRace,varClass)
	-- Create DB structure for new toon
	if not Liquid_Wealth.db.realm.toon[varPlayer] then --Checks to see if current toon is in the database
	    Liquid_Wealth.db.realm.toon[varPlayer] = {};
        Liquid_Wealth.db.realm.toon[varPlayer].accountID = 
        {
            Type=varAccountType,PSK=varPSK,
            
        }
        Liquid_Wealth.db.realm.toon[varPlayer].unitID=varSex..":"..varRace..":"..varClass
        Liquid_Wealth.db.realm.toon[varPlayer].bagID = {};
        Liquid_Wealth.db.realm.toon[varPlayer].playergold = 0;
		Liquid_Wealth.db.realm.toon[varPlayer].lastChecked = 0;
	end
end

function Liquid_Wealth:ConvItemDataToDB(BagItemLink,VenderTotal,AuctionTotal)--Convert BagInfo to my format (ITEMID:VENDERTOTAL:ACUTIONTOTAL)
    local convString = "";
    if not (BagItemLink == "Bank") and not (BagItemLink == "Backpack") and not (BagItemLink == "NONE") then --Don't try to convert Bank or Packpack.
       local _,itemId, _, _, _, _, _, _, _ = strsplit(":", BagItemLink)
        convString=itemId..":"..VenderTotal..":"..AuctionTotal;
    else
        convString=BagItemLink..":"..VenderTotal..":"..AuctionTotal;
    end
    return convString;
end

function Liquid_Wealth:ConvItemDataFromDB(BagId, Player) --Convert BagInfo from my format (ITEMID:VENDERTOTAL:ACUTIONTOTAL)
    if not Liquid_Wealth.db.realm.toon[Player].bagID[BagId] then return 0,0,0 end;
    local rawString = Liquid_Wealth.db.realm.toon[Player].bagID[BagId];
    local BagItemLink,VenderTotal,AuctionTotal = strsplit(":",rawString);
    return  BagItemLink,tonumber(VenderTotal),tonumber(AuctionTotal);
end

function Liquid_Wealth:genHexPSK() --Builds a hex ID that is used for to commfired remote sending.
    ranString=""
    for i=1,8 do
        tempVar=""
        tempVar=math.random(0,15)
        if tempVar==10 then
            ranString=ranString.."A"
        elseif tempVar==11 then
            ranString=ranString.."B"
        elseif tempVar==12 then
            ranString=ranString.."C"
        elseif tempVar==13 then
            ranString=ranString.."D"
        elseif tempVar==14 then
            ranString=ranString.."E"
        elseif tempVar==15 then
            ranString=ranString.."F"
        else
            ranString=ranString..tempVar
        end
    end
   return ranString
end
